<?php
/**
 * @package	Website Antivirus Scanner for Joomla
 * @copyright	Copyright (C) 2018 SiteGuarding.com. All rights reserved.
 * @GNU General Public License
 */
defined( '_JEXEC' ) or die;

error_reporting(0);
ini_set("display_errors", "Off");

if (version_compare(JVERSION, '3.0', '<'))
{
	if (JFactory::getApplication()->get('jquery') !== true)
	{
		// Load jQuery in no conflict mode with B/C support
		JHtml::script('../media/com_jmwascanner/jquery.min.js');
		JHtml::script('../media/com_jmwascanner/jquery-migrate.min.js');
		JHtml::script('../media/com_jmwascanner/jquery-noconflict.js');
		JFactory::getApplication()->set('jquery', true);
	}
}
else
{
JHtml::_('jquery.framework'); // load jquery
//JHtml::_('jquery.ui');
}

$user = JFactory::getUser();
$userId = $user->get( 'id' );
JToolBarHelper::title( JText::_( 'Website Antivirus Scanner for Joomla' ));

$document = JFactory::getDocument();
$document->addStyleSheet('../media/com_jmwascanner/semantic.min.css');
$document->addScript('../media/com_jmwascanner/semantic.min.js');

define('_SITEGUARDING_WAP', 1);
define('_SITEGUARDING_VERSION', '2.0');
define('_SITEGUARDING_CORE_UPDATE', true);
define('_SITEGUARDING_PATH', dirname(__FILE__));

if (!defined('DIRSEP'))
{
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') define('DIRSEP', '\\');
    else define('DIRSEP', '/');
}


$app = JFactory::getApplication();

?>
<div class="ui grid">
  <div class="three wide column">
    <div class="ui vertical fluid tabular menu">
      <a class="item<?php if (!isset($_GET['view'])) echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner' ); ?>"><i class="desktop icon"></i>Dashboard
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'antivirus') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=antivirus' ); ?>"><i class="crosshairs icon"></i>Antivirus
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'blacklists') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=blacklists' ); ?>"><i class="eye icon"></i>Blacklists
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'firewall') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=firewall' ); ?>"><i class="shield alternate icon"></i>Firewall
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'settings') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=settings' ); ?>"><i class="cogs icon"></i>Settings & Tools
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'extensions') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=extensions' ); ?>"><i class="plug icon"></i>Security Extensions
      </a>
      <a class="item<?php if (isset($_GET['view']) && $_GET['view'] == 'help') echo ' active'?>" href="<?php echo JRoute::_( 'index.php?option=com_jmwascanner&view=help' ); ?>"><i class="comments outline icon"></i>Help
      </a>
    </div>
  </div>
  <div class="twelve wide centered  stretched column">
    <div class="ui segment">


<?php



    include_once(dirname(__FILE__).DIRSEP.'classes'.DIRSEP.'func_general.php');
	
    $tmp_data = FUNC_WAP2_general::Get_SQL_Params(array('last_core_update', 'access_key'));
    if ($tmp_data['last_core_update'] < date("Y-m-d") && _SITEGUARDING_CORE_UPDATE)
    {
        FUNC_WAP2_general::Set_SQL_Params( array('last_core_update' => date("Y-m-d")));
        
        $avp_license_info = FUNC_WAP2_general::GetLicenseInfo(FUNC_WAP2_general::GetDomain(), $tmp_data['access_key']);
    }



	if ( isset($_GET['task']) && $_GET['task'] == 'standalone' )
	{
		error_reporting(0);
        
        FUNC_WAP2_general::RecoveryMode(trim($_GET['access_key']));
	}
	
    FUNC_WAP2_general::Init_Front();
    FUNC_WAP2_general::Init();	
	
	if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'antivirus') 
	{
        if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_avp_refresh')
        {
			FUNC_WAP2_general::UpdateLicenseInfo();
			echo 'OK';
			die;
        }	
		
		if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_scan_sql')
        {
			WAP2_AVP_SEO_SG_Protection::MakeAnalyze();
			echo 'OK';
			die;
        }
		
		if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_scan_avp')
        {

			ini_set('max_execution_time',7200);
			set_time_limit ( 7200 );
			
			FUNC_WAP2_antivirus::StartScanner();

			echo 'OK';
			die;
        }
		//FUNC_WAP2_antivirus::StartScanner();
        if (isset($_GET['action']) && $_GET['action'] == 'view_file')
        {
            FUNC_WAP2_antivirus::PageHTML_viewfile();
        }
        else FUNC_WAP2_antivirus::PageHTML();
    }
	else if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'blacklists') 
	{
        if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_scan_blacklist')
        {
            FUNC_WAP2_blacklists::UpdateBlacklistStatus();
			echo 'OK';
			die;
        }
        
        FUNC_WAP2_blacklists::PageHTML();
    }
	else if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'firewall') 
	{
		if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_enable_Firewall')
        {

			$params = FUNC_WAP2_general::Get_SQL_Params(array('firewall_status'));
			if (intval($params['firewall_status']) == 0)
			{
				$params['firewall_status'] = 1;
				FUNC_WAP2_firewall::ChangeFirewallStatus(true);
			}
			else {
				$params['firewall_status'] = 0;
				FUNC_WAP2_firewall::ChangeFirewallStatus(false);
				
			}
			FUNC_WAP2_general::Set_SQL_Params($params);

			echo 'OK';
			die;
        }
		
        FUNC_WAP2_firewall::PageHTML();
    }
	else if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'settings') 
	{
        FUNC_WAP2_settings::PageHTML();
    }
	else if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'extensions') 
	{
        FUNC_WAP2_extensions::PageHTML();
    }
	else if (isset($_GET['option']) && $_GET['option'] == 'com_jmwascanner' && isset($_GET['view']) && $_GET['view'] == 'help') 
	{
        FUNC_WAP2_help::PageHTML();
    } else {
		
		if (isset($_POST['action']) && $_POST['action'] == 'plgwap2_ajax_avp_refresh')
        {
			FUNC_WAP2_general::UpdateLicenseInfo();
			echo 'OK';
			die;
        }
		
        FUNC_WAP2_dashboard::PageHTML();   		
	}

	FUNC_WAP2_general::ModalPopup();

echo '</div></div></div>';







?>